<script setup lang="ts">
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import SContextualNavbar from '@/shared/navbar/components/SContextualNavbar.vue'
    import { computed, ref, watch } from 'vue'
    import { useMsal } from '@/plugins/msal/useMsal'
    import SAuthenticationButton from '@/components/ui/SAuthenticationButton.vue'
    import SFooter from '@/components/layout/SFooter.vue'
    import { useUserStore } from '@/shared/user/stores/UserStore'

    import { ServiceOffer } from '@/serviceOffer/entities/serviceOffer/ServiceOffer'
    import SServiceOffer from '@/serviceOffer/components/serviceOffer/SServiceOffer.vue'
    import { ServiceOfferApi } from '@/serviceOffer/entities/serviceOffer/ServiceOfferApi'
    import SSignInButton from '@/components/ui/SSignInButton.vue'

    import SMessageList from '@/shared/administration/views/messages/MessageList.vue'
    import { serviceOfferMapper } from '@/serviceOffer/entities/serviceOffer/ServiceOfferMapper'
    import { isDefined } from '@/shared/helpers/types'
    import useSWRV from '@/shared/swrv/use-swrv'
    import { ServiceOfferDto } from '@/serviceOffer/entities/serviceOffer/ServiceOfferDto'
    import LocalStorageCache from '@/shared/swrv/cache/adapters/localStorage'

    const menuOpen = ref(false)

    const msal = useMsal()
    const userStore = useUserStore(msal)

    const displayName = computed(() => {
        if (msal.accounts.value.length > 0) {
            const name = msal.accounts.value[0].name
            if (name) {
                return name
            }
        }
        return ''
    })

    const serviceOffers = ref<ServiceOffer[] | undefined>(undefined)
    const serviceOfferApi = new ServiceOfferApi(msal)

    const {
        data: serviceOffersDto,
        isValidating: isValidatingServiceOffers,
        mutate: mutateServiceOffers,
    } = useSWRV<ServiceOfferDto[]>(
        '/offres-de-service',
        async () => {
            return serviceOfferMapper.toDtoArray(await serviceOfferApi.getAll())
        },
        {
            cache: new LocalStorageCache('swrv'),
            revalidateDebounce: 500,
            revalidateOnFocus: false,
        }
    )

    watch([() => msal.accounts, () => userStore.isImpersonating], () => {
        mutateServiceOffers()
    })

    watch(
        serviceOffersDto,
        () => {
            if (isDefined(serviceOffersDto.value)) {
                serviceOffers.value = serviceOfferMapper.fromDtoArray(
                    serviceOffersDto.value
                )
            }
        },
        { immediate: true }
    )
</script>

<template>
    <s-contextual-navbar
        page-title="Mes applications"
        :page-is-loading="isValidatingServiceOffers === true"
    >
        <template #contextualButtons>
            <v-menu v-model="menuOpen">
                <template #activator="{ props }">
                    <v-btn v-bind="props" color="secondary">
                        <v-icon size="x-large">
                            {{
                                userStore.isImpersonating
                                    ? 'mdi-ghost-outline'
                                    : 'mdi-account-circle-outline'
                            }}
                        </v-icon>

                        <p
                            v-if="$vuetify.display.smAndUp"
                            data-cy="logged-in-display-name"
                        >
                            {{ displayName }}
                        </p>
                        <v-icon>
                            {{
                                menuOpen ? 'mdi-chevron-up' : 'mdi-chevron-down'
                            }}
                        </v-icon>
                    </v-btn>
                </template>
                <v-list>
                    <template v-if="userStore.isImpersonating">
                        <v-list-item>
                            <v-list-item-subtitle>
                                Usurpation de
                                <strong>{{
                                    userStore.impersonatedEmail
                                }}</strong>
                            </v-list-item-subtitle>
                            <v-list-item-title class="text-center mt-2">
                                <v-btn
                                    prepend-icon="mdi-ghost-off-outline"
                                    variant="text"
                                    color="gray"
                                    @click="userStore.stopImpersonating"
                                >
                                    <p>Arrêter d'usurper</p>
                                </v-btn>
                            </v-list-item-title>
                        </v-list-item>
                    </template>
                    <template v-else>
                        <v-list-item>
                            <v-list-item-title>
                                <s-authentication-button />
                            </v-list-item-title>
                        </v-list-item>
                    </template>
                </v-list>
            </v-menu>
            <v-btn
                v-if="userStore.currentUser.reachableRoles.includes('ROLE_GOD')"
                data-cy="btn-silab-admin"
                icon="mdi-cog-outline"
                color="on-background"
                :to="{
                    name: 'admin/general',
                }"
            ></v-btn>
        </template>
    </s-contextual-navbar>
    <v-main>
        <s-content-container>
            <s-message-list />
            <template v-if="userStore.currentUser.id === 'ANONYMOUS'">
                <v-alert
                    type="info"
                    variant="outlined"
                    title="Utilisateur non connecté"
                >
                    <template #text>
                        <p>
                            Pour accéder au fonctionnalités de Silab, merci de
                            <s-sign-in-button>vous connecter</s-sign-in-button>
                        </p>
                    </template>
                </v-alert>
            </template>
            <v-container>
                <v-row>
                    <v-col
                        v-for="serviceOffer in serviceOffers"
                        :key="serviceOffer.id"
                        cols="12"
                        xs="12"
                        sm="6"
                        md="3"
                        lg="3"
                        xl="3"
                    >
                        <s-service-offer :service-offer="serviceOffer" />
                    </v-col>
                </v-row>
            </v-container>
        </s-content-container>
    </v-main>

    <s-footer />
</template>
